NAME	DELAYFUNCS
PUBLIC		DELAYUS, DELAYMS

?PR?DELAYASM	SEGMENT		CODE
	RSEG	?PR?DELAYASM

; 1 means STC-Y1, include STC89/STC90
; 3 means STC-Y3, include STC10/STC11/STC12/STC15F104E/STC15F204EA
; 5 means STC-Y5, include STC15(STC15F104E/STC15F204EA not included)
; 6 means STC-Y6, include STC8F/STC8A/STC8G/STC8H
; 7 means STC32 instrcttion set, include STC32G/STC32F
INSTRSET	EQU		6

; delay R5 * 1us
DELAYUS:
	DELAYUSL1:
		IF(INSTRSET = 6)
			REPTTIME	SET 	9
		ELSE
			REPTTIME	SET 	8
		ENDIF
		REPT	REPTTIME
			NOP
		ENDM
		DJNZ	R5, DELAYUSL1
	RET

DELAYMS:
	IF(INSTRSET = 7)
		PUSH	R3
		PUSH	R4
	ENDIF
	DELAYMSL1:
		IF(INSTRSET = 7)
			MOV		R4, #14D
		ELSEIF(INSTRSET = 6)
			MOV		R4, #27D
		ELSEIF(INSTRSET = 5 OR INSTRSET = 3)
			MOV		R4, #109D
		ENDIF
		DELAYMSL2:
			IF(INSTRSET = 7)
				MOV		R3, #213D
			ELSEIF(INSTRSET = 6)
				MOV		R3, #147D
			ELSEIF(INSTRSET = 5)
				MOV		R3, #26D
			ENDIF
			DJNZ	R3, $
			DJNZ	R4, DELAYMSL2
		IF(INSTRSET = 7)
			REPT	12
				NOP
			ENDM
		ELSEIF(INSTRSET = 6)
			REPT	9
				NOP
			ENDM
		ELSEIF(INSTRSET = 5)
			REPT	4
				NOP
			ENDM
		ENDIF
		DJNZ	R5, DELAYMSL1
	IF(INSTRSET = 7)
		POP		R4
		POP		R3
	ENDIF
	RET

END
